![api-docker](https://github.com/nocalhost/nocalhost/workflows/api-docker/badge.svg?branch=main)
![nhctl](https://github.com/nocalhost/nocalhost/workflows/nhctl/badge.svg?branch=main)
[![Go Report Card](https://goreportcard.com/badge/github.com/nocalhost/nocalhost)](https://goreportcard.com/report/github.com/nocalhost/nocalhost)
[![LICENSE](https://img.shields.io/github/license/nocalhost/nocalhost)](https://github.com/nocalhost/nocalhost/blob/main/LICENSE)

<p align="center">
    <a href="https://nocalhost.dev">
        <img src='https://user-images.githubusercontent.com/3713305/123894696-305fc480-d991-11eb-960a-e87d8bd7acbf.png' width="200"/>
    </a>
    <br />
    <em>让云原生开发更高效</em>
</p>

## Nocalhost

Nocalhost 一词源于 No Local，它是一款基于 IDE 的云原生开发工具，提供实时的云原生应用开发体验。

使用 Nocalhost 开发云原生应用时，任何代码更改都可以立即在远程端生效，免去了提交、构建和推送镜像等步骤。能大幅提速编码自测的反馈过程，所以代码修改能实现秒级生效，提升研发效率。

为了让你更好的了解 Nocalhost，建议您可以先阅读我们的博客文章 [Nocalhost - 重新定义云原生开发](https://nocalhost.dev/zh/Blog/redefine-cloud-native-dev-environment/)

[![Nocalhost](https://img.youtube.com/vi/z7I-vopn-gQ/0.jpg)](https://www.bilibili.com/video/BV1RX4y1w7hB?share_source=copy_web)

## 核心功能

### IDE 支持

Nocalhost 为 JetBrains 和 VSCode 提供易于使用的 IDE 插件，让开发人员能够在他们的本地机器上可以方便地开发和调试基于云的应用程序。

## 一键连接远端 K8s 集群，快速开始云原生应用开发

无需再本地机器中配置复杂的开发环境，Nocalhost 可以帮助您一键连接到任何 Kubernetes 环境，快速开始云原生应用的开发。

### 代码修改秒级生效

自动的文件同步能将本地代码修改实时同步到远端容器，消除了提交、构建和推送步骤，能大幅提速编码自测的反馈过程，所以代码修改能实现秒级生效。

### 独立的开发空间

每个团队成员都可以享受自己独立的发展空间，确保在开发过过程中不受他人干扰。

## 快速入门

* [安装](https://nocalhost.dev/zh-CN/docs/installation)
* [快速开始](https://nocalhost.dev/zh-CN/docs/quick-start)
* [核心概念](https://nocalhost.dev/zh-CN/docs/introduction)

## 文档

可以访问我们的 [Nocalhost](https://nocalhost.dev/) 查阅所有文档

## 社区

* Slack: [Nocalhost Slack Channel](https://nocalhost.slack.com/)
* 微信群：扫码添加小助手，发送 **Nocalhost**，小助手会拉您进群

![nocal-host-wechat](https://user-images.githubusercontent.com/3713305/123894953-a2d0a480-d991-11eb-88af-9082d14b0c2c.png)

## Blogs

* [专访 CNCF 大使王炜：让云原生开发回归原始而又简单](https://mp.weixin.qq.com/s/nb4pgaqFX_gssx4HySKIoA)
* [Nocalhost - 重新定义云原生开发环境](https://mp.weixin.qq.com/s/Royq17eSgC7c-WSPbKlfuw)
* [开发环境上云，打造五星级开发体验](https://help.coding.net/insight/posts/b18262fc/)
* [Nocalhsot vs. Other Software](https://nocalhost.dev/zh/Blog/compare-with-x/)
* [如何调试 Kubernetes 中的微服务——proxy、sidecar 还是 service mesh？](https://www.tetrate.io/blog/how-to-debug-microservices-in-kubernetes-with-proxy-sidecar-or-service-mesh/?lang=zh-hans)
* [Nocalhost 云端开发](https://codeandcode.cn/2021/01/15/Nocalhost%E4%BB%8B%E7%BB%8D/)
* [解读容器的 2020：寻找云原生的下一站](https://xie.infoq.cn/article/b0b27ecb2ae91ff59e5faa392)
* [新一代架构 water：超越 Serverless 的云研发架构模式](https://www.phodal.com/blog/next-generation-code-architecture/)


## 宣讲和资料

| 类型 | 连接 |
| ---------- | ---- |
| :video_camera: &nbsp; Nocalhost Youtube | [https://space.bilibili.com/1849382439](https://space.bilibili.com/1849382439) |
| :video_camera: &nbsp; 开源的云原生开发环境 —— Nocalhost | [https://www.bilibili.com/video/BV1ch411C716](https://www.bilibili.com/video/BV1ch411C716) |
| :video_camera: &nbsp; Nocalhost - 五星级的云原生开发体验 | [https://cloud.tencent.com/developer/salon/salon-1398/agenda-10004](https://cloud.tencent.com/developer/salon/salon-1398/agenda-10004) |

## 贡献

查看我们的 [贡献说明](./CONTRIBUTING.md)

## 行为守则

Nocalhost 遵循 [CNCF 行为守则](https://github.com/cncf/foundation/blob/master/code-of-conduct.md)

## 许可

Nocalhost 使用 [Apache 2.0 许可证](./LICENSE)

## 路线图

参考 [ROADMAP](./ROADMAP.md)
